diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index b325afe95..bf794ec4c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -3,9 +3,6 @@ package net.minecraft.client.render.tileentity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
-import net.minecraft.client.render.model.ModelPigman;
-import net.minecraft.client.render.model.ModelPlayer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
@@ -14,7 +11,6 @@ import net.minecraft.core.block.entity.TileEntityStatue;
 import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.*;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -22,10 +18,13 @@ import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 import java.util.HashMap;
 import java.util.Map;
 
+import static net.minecraft.client.render.entity.MobRenderer.ENTITY_RENDER_SCALE;
+
 public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatue> {
     public static final @NotNull Map<@NotNull Block<?>, @NotNull String> BLOCK_SKIN_MAP = new HashMap<>();
     static {
@@ -38,166 +37,151 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         BLOCK_SKIN_MAP.put(Blocks.STATUE_PIGMAN_LOWER, basePath + "pigman.png");
     }
 
-    private final ModelPlayer model;
-    private final ModelBiped modelArmorA;
-    private final ModelBiped modelArmorB;
-    private final ModelPigman modelPigman;
-
     public TileEntityRendererStatue() {
-        this.model = new ModelPlayer(0.0f);
-        this.modelPigman = new ModelPigman(0.0f, 0.0f);
-        this.modelArmorA = new ModelBiped(1.0f);
-        this.modelArmorB = new ModelBiped(0.5f);
+        super();
     }
 
-    private ModelBiped model(boolean isPigman) {
+    private @NotNull StaticEntityModel model(final boolean isPigman) {
         if (isPigman) {
-            return this.modelPigman;
+            return getModel("main.pigman");
         } else {
-            return this.model;
+            return getModel("main");
         }
     }
 
-    public void renderAt(@Nullable ItemStack heldStack, final int meta, final @NotNull Block<?> lowerBlock, final @NotNull TileEntityStatue.Pose pose, final @Nullable IArmorWearing<HumanArmorShape> armorWearer, double x, double y, double z) {
+    public void renderAt(@NotNull final Tessellator tessellator, @Nullable final ItemStack heldStack, final int meta, final @NotNull Block<?> lowerBlock, final @NotNull TileEntityStatue.Pose pose, final @Nullable IArmorWearing<HumanArmorShape> armorWearer, final double x, final double y, final double z) {
         final boolean isPigman = lowerBlock == Blocks.STATUE_PIGMAN_LOWER;
 
+        final StaticEntityModel model = model(isPigman);
+
         GL12.glEnable(GL12.GL_RESCALE_NORMAL);
-        final float scale = 0.0625f;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        loadTexture(BLOCK_SKIN_MAP.getOrDefault(lowerBlock, BLOCK_SKIN_MAP.get(Blocks.STATUE_STONE_LOWER)));
+        bindTexture(BLOCK_SKIN_MAP.getOrDefault(lowerBlock, BLOCK_SKIN_MAP.get(Blocks.STATUE_STONE_LOWER)));
         GL11.glPushMatrix();
-        GL11.glTranslated(x + 0.5, y + 1.5, z + 0.5);
-        float rotation = (float)(meta * 360) / 16F;
+        GL11.glTranslated(x + 0.5, y, z + 0.5);
+        final float rotation = (float)(meta * 360) / 16F;
         GL11.glRotatef(-rotation, 0.0F, 1.0F, 0.0F);
-        GL11.glScalef(1, -1, -1);
         GL11.glDisable(GL11.GL_CULL_FACE);
 
             GL11.glPushMatrix();
-            GL11.glScalef(scale, scale, scale);
-            renderModel(this.model(isPigman), pose);
+            GL11.glScalef(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
+            model.resetBones();
+            renderModel(tessellator, model, pose);
             if (armorWearer != null) {
                 for (int i = 0; i < 4; i++) {
-                    renderArmor(armorWearer, i, pose);
+                    renderArmor(tessellator, armorWearer, i, pose);
                 }
             }
+            renderHeldItem(heldStack, isPigman);
             GL11.glPopMatrix();
 
-        renderHeldItem(heldStack, isPigman);
         GL11.glEnable(GL11.GL_CULL_FACE);
         GL11.glPopMatrix();
         GL12.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    private void renderHeldItem(final @Nullable ItemStack itemStack, boolean isPigman) {
+    private void renderHeldItem(final @Nullable ItemStack itemStack, final boolean isPigman) {
         if(itemStack != null) {
             GL12.glEnable(GL12.GL_RESCALE_NORMAL);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            model(isPigman).armRight.translateTo(0.0625F);
-            GL11.glRotatef(-90, 1, 0, 0);
-            GL11.glScalef(-1, 1, -1);
-            GL11.glTranslatef(1/16f, 2/16f, -10f/16f);
+            model(isPigman).translateToBone("rightItem");
+            GL11.glScalef(-1, 1, 1);
+            GL11.glScalef(ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE);
             ItemModelDispatcher.getInstance().getDispatch(itemStack).render(Tessellator.instance, null, itemStack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, 1f, 1f, 1f, false);
             GL11.glEnable(GL11.GL_CULL_FACE);
             GL12.glDisable(GL12.GL_RESCALE_NORMAL);
         }
     }
 
-    private void applyPose(TileEntityStatue.Pose pose, ModelBiped model) {
-        model.armLeft.xRot = pose.leftArmPitch;
-        model.armRight.xRot = pose.rightArmPitch;
-        model.legLeft.xRot = pose.leftLegPitch;
-        model.legRight.xRot = pose.rightLegPitch;
-        model.head.xRot = pose.headPitch;
-        model.head.yRot = pose.headYaw;
-        if (model instanceof ModelPigman) {
-            ((ModelPigman) model).nose.xRot = pose.headPitch;
-            ((ModelPigman) model).nose.yRot = pose.headYaw;
-        }
-    }
 
-    private void renderModel(ModelBiped model, TileEntityStatue.Pose pose) {
-        final float scale = 1.0f;
-
-        model.setupAnimation(null, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, scale, 1f);
-        applyPose(pose, model);
-
-        model.head.render(scale);
-        model.body.render(scale);
-        model.armRight.render(scale);
-        model.armLeft.render(scale);
-        model.legRight.render(scale);
-        model.legLeft.render(scale);
-        model.hair.render(scale);
-        if (model instanceof ModelPigman) {
-            ((ModelPigman) model).nose.render(scale);
-        }
+    private void renderModel(@NotNull final Tessellator tessellator, @NotNull final StaticEntityModel model, @NotNull final TileEntityStatue.Pose pose) {
+        model.getTransform("leftArm").rotX = pose.leftArmPitch;
+        model.getTransform("rightArm").rotX = pose.rightArmPitch;
+        model.getTransform("leftLeg").rotX = pose.leftLegPitch;
+        model.getTransform("rightLeg").rotX = pose.rightLegPitch;
+        model.getTransform("head").rotX = pose.headPitch;
+        model.getTransform("head").rotY = pose.headYaw;
+        model.render(tessellator);
     }
 
     @Override
-    public void doRender(Tessellator tessellator, TileEntityStatue tileEntity, double x, double y, double z,
-                         float partialTick) {
-        renderAt(tileEntity.getHeldItem(), tileEntity.getBlockMeta(), tileEntity.getBlock(), tileEntity.getPose(), tileEntity, x, y, z);
+    public void doRender(@NotNull final Tessellator tessellator, @NotNull final TileEntityStatue tileEntity, final double x, final double y, final double z, final float partialTick) {
+        renderAt(tessellator, tileEntity.getHeldItem(), tileEntity.getBlockMeta(), tileEntity.getBlock(), tileEntity.getPose(), tileEntity, x, y, z);
         renderShadow(Minecraft.getMinecraft().currentWorld, tessellator, tileEntity.x, tileEntity.y, tileEntity.z, x, y, z, 2.0f, partialTick);
     }
 
-    private boolean renderArmor(final @NotNull IArmorWearing<HumanArmorShape> armorWearer, int layer, TileEntityStatue.Pose pose) {
-        ItemStack itemstack = armorWearer.getItemInArmorSlot(HumanArmorShape.values()[(armorWearer.getNumArmorSlots() - 1) - layer]);
+    private boolean renderArmor(final @NotNull Tessellator tessellator, final @NotNull IArmorWearing<? super HumanArmorShape> armorWearer, final int layer, final TileEntityStatue.Pose pose) {
+        final ItemStack itemstack = armorWearer.getItemInArmorSlot(HumanArmorShape.values()[(armorWearer.getNumArmorSlots() - 1) - layer]);
         if (itemstack != null) {
-            Item item = itemstack.getItem();
-            ModelBiped toDraw = null;
+            final Item item = itemstack.getItem();
             if (item instanceof ItemQuiver) {
-                loadTexture("/assets/minecraft/textures/armor/quiver.png");
-                ModelBiped modelBiped = modelArmorA;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                toDraw = modelBiped;
-            }
-            if (item instanceof ItemQuiverEndless) {
-                loadTexture("/assets/minecraft/textures/armor/quiver_golden.png");
-                ModelBiped modelBiped = modelArmorA;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                toDraw = modelBiped;
-            }
-            if (item == Items.ARMOR_BOOTS_ICESKATES) {
-                loadTexture("/assets/minecraft/textures/armor/skates.png");
-                ModelBiped modelBiped = modelArmorA;
-                modelBiped.legRight.visible = layer == 2 || layer == 3;
-                modelBiped.legLeft.visible = layer == 2 || layer == 3;
-                toDraw = modelBiped;
-            }
-            if (item instanceof IArmorItem && ((IArmorItem) item).getArmorMaterial() != null) {
-                IArmorItem armorItem = (IArmorItem) item;
-                loadTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
-                ModelBiped modelBiped = layer != 2 ? modelArmorA : modelArmorB;
-                modelBiped.head.visible = layer == 0;
-                modelBiped.hair.visible = layer == 0;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                modelBiped.armRight.visible = layer == 1;
-                modelBiped.armLeft.visible = layer == 1;
-                modelBiped.legRight.visible = layer == 2 || layer == 3;
-                modelBiped.legLeft.visible = layer == 2 || layer == 3;
-                toDraw = modelBiped;
+                bindTexture("/assets/minecraft/textures/armor/quiver.png");
+            } else if (item instanceof ItemQuiverEndless) {
+                bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
+            } else if (item == Items.ARMOR_BOOTS_ICESKATES) {
+                bindTexture("/assets/minecraft/textures/armor/skates.png");
+            } else if (item instanceof IArmorItem) {
+                final IArmorItem armorItem = (IArmorItem) item;
+                if (armorItem.getArmorMaterial() == null) return false;
+                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
+            } else {
+                return false;
             }
 
-            if (toDraw != null) {
-                renderModel(toDraw, pose);
-                return true;
+            final StaticEntityModel model;
+            switch (layer) {
+                case 3:
+                    model = getModel("armor.boots");
+                    model.resetBones();
+                    model.getTransform("chest").visible = false;
+                    model.getTransform("head").visible = false;
+                    model.getTransform("rightArm").visible = false;
+                    model.getTransform("leftArm").visible = false;
+                    break;
+                case 2:
+                    model = getModel("armor.leggings");
+                    model.resetBones();
+                    model.getTransform("head").visible = false;
+                    model.getTransform("rightArm").visible = false;
+                    model.getTransform("leftArm").visible = false;
+                    break;
+                case 1:
+                    model = getModel("armor.chestplate");
+                    model.resetBones();
+                    model.getTransform("head").visible = false;
+                    model.getTransform("rightLeg").visible = false;
+                    model.getTransform("leftLeg").visible = false;
+                    break;
+                case 0:
+                    model = getModel("armor.helmet");
+                    model.resetBones();
+                    model.getTransform("chest").visible = false;
+                    model.getTransform("rightArm").visible = false;
+                    model.getTransform("leftArm").visible = false;
+                    model.getTransform("rightLeg").visible = false;
+                    model.getTransform("leftLeg").visible = false;
+                    break;
+                default:
+                    return false;
             }
+            renderModel(tessellator, model, pose);
+            return true;
         }
         return false;
     }
 
-    private void renderShadow(World world, Tessellator tessellator, int bx, int by, int bz, double rx, double ry, double rz, float opacity, float partialTick)
+    private void renderShadow(final @NotNull World world, final @NotNull Tessellator tessellator, final int bx, final int by, final int bz, final double rx, final double ry, final double rz, final float opacity, final float partialTick)
     {
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        TextureManager textureManager = renderDispatcher.textureManager;
+        final TextureManager textureManager = this.renderDispatcher.textureManager;
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
-        float shadowSize = 0.5f;
-        float shadowOffs = 0.8f / 2.0f;
+        final float shadowSize = 0.5f;
+        final float shadowOffs = 0.8f / 2.0f;
         GL11.glDepthMask(false);
         tessellator.startDrawingQuads();
 
-        int blockId = world.getBlockId(bx, by - 1, bz);
+        final int blockId = world.getBlockId(bx, by - 1, bz);
         if(blockId > 0 && world.getBlockLightValue(bx, by, bz) > 3)
         {
             renderShadowOnBlock(world, tessellator, Blocks.blocksList[blockId], bx, by, bz, rx, ry + (double)shadowOffs, rz, opacity, shadowSize);
@@ -209,8 +193,8 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         GL11.glDepthMask(true);
     }
 
-    private void renderShadowOnBlock(World world, Tessellator tessellator, Block<?> block, int bx, int by, int bz, double rx, double ry, double rz,
-                                     float opacity, float size)
+    private void renderShadowOnBlock(final @NotNull World world, final @NotNull Tessellator tessellator, final Block<?> block, final int bx, final int by, final int bz, final double rx, final double ry, final double rz,
+                                     final float opacity, final float size)
     {
         if(!block.isCubeShaped())
         {
@@ -228,19 +212,19 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
             alpha = 1.0D;
         }
         tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float)alpha);
-        AABB aabb = block.getCollisionBoundingBoxFromPool(world, bx, by - 1, bz);
+        final AABB aabb = block.getCollisionBoundingBoxFromPool(world, bx, by - 1, bz);
         if(aabb == null) {
             return;
         }
-        double xMin = rx - 0.5f;
-        double xMax = rx + (aabb.maxX - aabb.minX) - 0.5f;
-        double yMin = (ry + (aabb.maxY - aabb.minY)) - 1.39;
-        double zMin = rz - 0.5f;
-        double zMax = rz + (aabb.maxZ - aabb.minZ) - 0.5f;
-        float f2 = (float)((rx - xMin) / 2D / (double)size + 0.5D);
-        float f3 = (float)((rx - xMax) / 2D / (double)size + 0.5D);
-        float f4 = (float)((rz - zMin) / 2D / (double)size + 0.5D);
-        float f5 = (float)((rz - zMax) / 2D / (double)size + 0.5D);
+        final double xMin = rx - 0.5f;
+        final double xMax = rx + (aabb.maxX - aabb.minX) - 0.5f;
+        final double yMin = (ry + (aabb.maxY - aabb.minY)) - 1.39;
+        final double zMin = rz - 0.5f;
+        final double zMax = rz + (aabb.maxZ - aabb.minZ) - 0.5f;
+        final float f2 = (float)((rx - xMin) / 2D / (double)size + 0.5D);
+        final float f3 = (float)((rx - xMax) / 2D / (double)size + 0.5D);
+        final float f4 = (float)((rz - zMin) / 2D / (double)size + 0.5D);
+        final float f5 = (float)((rz - zMax) / 2D / (double)size + 0.5D);
         tessellator.addVertexWithUV(xMin + 0.5f, yMin, zMin + 0.5f, f2, f4);
         tessellator.addVertexWithUV(xMin + 0.5f, yMin, zMax + 0.5f, f2, f5);
         tessellator.addVertexWithUV(xMax + 0.5f, yMin, zMax + 0.5f, f3, f5);
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index b1b6991c4..ab03c6b85 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -20,6 +20,7 @@ import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.WeatherManager;
 
 public class WorldClient extends World {
+    public static final WorldClient EMPTY_WORLD = new WorldClient();
 
     public WorldClient(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType) {
         super(saveHandler, name, seed, dimension, worldType);
